incoming_call() { __incoming_call "$@"; }
require callmonitor_config
require if_jfritz
require phonebook
require hash
require file
ensure_file "$CALLMONITOR_LISTENERS"
export INSTANCE=0
new_hash _provider
_provider_name() {
local provider=$1 name=
_provider_get "$provider" name
if empty "$name"; then
name="$(_pb_main --local -- get "$provider") "
_provider_put "$provider" "$name"
fi
echo "${name% }"
}
__incoming_call() {
__prepare_env
local event_spec source_pattern dest_pattern listener rule=0
while read -r event_spec source_pattern dest_pattern listener
do
case $event_spec in \#*|"") continue ;; esac
RULE=$rule \
__process_rule "$event_spec" "$source_pattern" "$dest_pattern" "$listener" &
let rule++
done < "$CALLMONITOR_LISTENERS"
wait
}
__prepare_env() {
local __
if ! empty "$SOURCE"; then
case $EVENT,$PROVIDER in
out:*,SIP*) SOURCE_NAME=$(_provider_name "$PROVIDER") ;;
*) false ;;
esac ||
SOURCE_NAME=$(_pb_main $SOURCE_OPTIONS -- get "$SOURCE")
else ## empty "$SOURCE"
case $EVENT in
out:*) SOURCE=$PROVIDER ;;
esac
fi
if ! empty "$SOURCE"; then
normalize_address "$SOURCE" display; SOURCE_DISP=$__
fi
if ! empty "$DEST"; then
case $EVENT,$PROVIDER in 
in:*,SIP*) DEST_NAME=$(_provider_name "$PROVIDER") ;;
*) false ;;
esac ||
DEST_NAME=$(_pb_main $DEST_OPTIONS -- get "$DEST")
else ## empty "$DEST"
case $EVENT in
in:*) DEST=$PROVIDER ;;
esac
fi
if ! empty "$DEST"; then
normalize_address "$DEST" display; DEST_DISP=$__
fi
__info "[$INSTANCE] EVENT=$EVENT SOURCE='$SOURCE' DEST='$DEST'" \
"SOURCE_NAME='$SOURCE_NAME' DEST_NAME='$DEST_NAME'"
__info "[$INSTANCE+] SOURCE_DISP='$SOURCE_DISP' DEST_DISP='$DEST_DISP'" \
"ID=$ID EXT=$EXT DURATION=$DURATION TIMESTAMP='$TIMESTAMP'" \
"PROVIDER=$PROVIDER"
local var_cm="SOURCE DEST SOURCE_NAME DEST_NAME SOURCE_DISP DEST_DISP EVENT
ID EXT DURATION TIMESTAMP PROVIDER"
export $var_cm
__dump $var_cm
}
__process_rule() {
local event_spec=$1 source_pattern=$2 dest_pattern=$3 listener=$4
__debug_rule "processing rule '$event_spec' '$source_pattern' '$dest_pattern' '$listener'"
if ! {
__match_event "$EVENT" "$event_spec" &&
__match SOURCE "$SOURCE" "$source_pattern" &&
__match DEST "$DEST" "$dest_pattern"
} then 
__debug_rule "FAILED"
return 1
fi
__debug_rule "SUCCEEDED"
__info_rule "ACTION: '$listener'"
set --
eval "$listener"
local status=$?
if ? "status != 0"; then
__debug_rule "listener failed with an exit status of $status"
fi
return 0
}
__debug_rule() {
__debug "[$INSTANCE:$RULE]" "$@"
}
__info_rule() {
__info "[$INSTANCE:$RULE]" "$@"
}
__match() {
local param=$1 value=$2 pattern=$3 result=1
local regexp=${pattern#!}
local shpat=${regexp#^}
shpat=${shpat%\$}
case $shpat in
*[!A-Za-z_0-9-]*)
if echo "$value" | egrep -q "$regexp"; then
result=0
fi
;;
*) # match simple patterns on our own
case $regexp in
^*) ;;
*) shpat="*$shpat" ;;
esac
case $regexp in
*\$) ;;
*) shpat="$shpat*" ;;
esac
case $value in
$shpat) result=0 ;;
esac
;;
esac
case $pattern in
!*) let result="!result" ;;
esac
if ? result == 0; then
__debug_rule "parameter $param='$value' matches pattern '$pattern'"
else
__debug_rule "parameter $param='$value' does NOT match" \
"pattern '$pattern'"
fi
return $result
}
__match_event() {
local event=$1 spec=$2 dir= type= - result=1 ifs=$IFS IFS=, pattern
set -f
for pattern in $spec; do
IFS=$ifs
case $pattern in
""|*:*:*)
;;
*:*) 
dir=${pattern%:*}
type=${pattern#*:}
case $event in $dir*:$type*) result=0;; esac
;;
*) 
case $event in $pattern*:*|*:$pattern*) result=0;; esac
;;
esac
if ? "result == 0"; then
__debug_rule "event '$event' matches pattern '$pattern'"
break
fi
done
if ? "result == 1"; then
__debug_rule "event '$event' does NOT match pattern '$spec'"
fi
return $result
}
